#ifndef __GRID__
#define __GRID__

class grid
{
public:
  enum { success, failure, win };
  grid(int w, int h);
  ~grid();
  void clear(void);  // clears the grid.
  void print(void);  // prints the contents of the grid.
  int addtoken(int col, char token); // adds a token
private:
  int haswon(int col, int row, char token);
  // haswon returns `win' on a win, else `success'
  int haswondir(int col, int row, char token, int dx, int dy);
  // haswondir is called by haswon, and searches in
  // a particular direction until a win is encountered
  // returns `win' if a win is encountered, else returns
  // `success'
  int width, height;
  char **array;
  int *size;
};

#endif __GRID__
